Python 使用sys.exc_info自己捕获异常详细信息

Python 使用sys.exc_info自己捕获异常详细信息

Python 使用sys.exc_info自己捕获异常详细信息

一般程序中,我们需要对异常进行捕获来保证程序的健壮。但是debug的时候,我们可能需要异常的详细信息,这时可以使用sys.exec_info来处理:

import traceback
import sys
try:
     raise ValueError('this is a exp')
except Exception as ex:
    ex_type, ex_val, ex_stack = sys.exc_info()
    print(ex_type)
    print(ex_val)
    for stack in traceback.extract_tb(ex_stack):
        print(stack)

将以上代码保存为文件test.py, 执行可以看到以下结果:

% python3 test.py 
<class 'ValueError'>
this is a exp
<FrameSummary file test.py, line 4 in <module>>

posted on 2017-10-25 18:59 dwSun 阅读(...) 评论(...) 编辑 收藏

表情包
插入表情
评论将由博主筛选后显示,对所有人可见 | 还能输入1000个字符
相关推荐
©️2020 CSDN 皮肤主题: 技术黑板 设计师:CSDN官方博客 返回首页